extends layout

block headContent
	+title(`Transaction ${txid}`)
	style.
		.field {
			word-wrap: break-word;
		}


block content
	if (result && result.getrawtransaction)
		h1.h3.word-wrap Transaction
			br
			small.text-monospace #{txid}
		hr

		ul.nav.nav-tabs.mb-3
			li.nav-item
				a.nav-link.active(data-toggle="tab", href="#tab-details", role="tab") Details
			li.nav-item
				a.nav-link(data-toggle="tab", href="#tab-scripts", role="tab") Scripts
			li.nav-item
				a.nav-link(data-toggle="tab", href="#tab-json", role="tab") JSON

		- DecimalRounded = Decimal.clone({ precision: 4, rounding: 2 })

		- var totalInputValue = new Decimal(0);
		if (result.getrawtransaction.vin.length == 0)
			- totalInputValue = totalInputValue.plus(new Decimal(coinConfig.blockRewardFunction(result.blockHeader.height, activeBlockchain)));
		else
			each txInput, txInputIndex in result.txInputs
				if (txInput)
					- var vout = txInput;
					if (vout.value)
						- totalInputValue = totalInputValue.plus(new Decimal(vout.value));

		- var totalOutputValue = new Decimal(0);
		each vout, voutIndex in result.getrawtransaction.vout
			- totalOutputValue = totalOutputValue.plus(new Decimal(vout.value));

		div.tab-content
			div.tab-pane.active(id="tab-details", role="tabpanel")
				if (global.specialTransactions && global.specialTransactions[txid])
					div.alert.alert-primary.shadow-sm.pb-0
						div.float-left(style="width: 55px; height: 55px; font-size: 18px;")
							i.fas.fa-certificate.fa-2x(style="margin-top: 10px;")

						h4.alert-heading.h6.font-weight-bold !{coinConfig.nameHtml} Fun

						// special transaction info
						- var stInfo = global.specialTransactions[txid];
						if (stInfo.alertBodyHtml)
							p
								span !{stInfo.alertBodyHtml}

								if (stInfo.referenceUrl && stInfo.referenceUrl.trim().length > 0 && stInfo.alertBodyHtml.indexOf(stInfo.referenceUrl) == -1)
									span
										a(href=stInfo.referenceUrl) Read more
						else
							p
								span #{stInfo.summary}

								if (stInfo.referenceUrl && stInfo.referenceUrl.trim().length > 0)
									span
										a(href=stInfo.referenceUrl) Read more

				- var isTxConfirmed = true;
				if (!result.getrawtransaction.confirmations || result.getrawtransaction.confirmations == 0)
					- isTxConfirmed = false;

				div.card.shadow-sm.mb-3
					div.card-body.px-2.px-md-3
						h2.h6.mb-0 Summary
						hr

						div.clearfix
						if (!isTxConfirmed)
							div.row
								div.summary-table-label Status
								div.summary-table-content.text-monospace
									span.text-danger Unconfirmed
							div.row
								div.summary-table-label Chain Length
								div.summary-table-content.text-monospace
									span #{txpoolDetails.entry.ancestorcount + txpoolDetails.entry.descendantcount -1}

						if (isTxConfirmed)
							div.row
								div.summary-table-label Block
								div.summary-table-content.text-monospace
									a(href=("/block/" + result.getrawtransaction.blockhash)) ##{result.blockHeader.height.toLocaleString()}

						if (isTxConfirmed)
							div.row
								div.summary-table-label Timestamp
								div.summary-table-content.text-monospace
									if (result.getrawtransaction.time)
										td.text-monospace
											- var timestampHuman = result.getrawtransaction.time;
											include includes/timestamp-human.pug
											small.ml-1 utc

											- var timeAgoTime = result.getrawtransaction.time;
											span.text-muted.ml-2 (
												include includes/time-ago-text.pug
												span ago)

							div.row
								div.summary-table-label Version
								div.summary-table-content.monospace #{result.getrawtransaction.version}

							div.row
								div.summary-table-label Size
								div.summary-table-content.text-monospace
									span #{result.getrawtransaction.size.toLocaleString()}
									small B

						if (result.getrawtransaction.locktime > 0)
							div.row
								div.summary-table-label Locktime
								div.summary-table-content.text-monospace
									if (result.getrawtransaction.locktime < 500000000)
										// the following is not a traling space
										span Spendable in block 
										a(href=("/block-height/" + result.getrawtransaction.locktime)) ##{result.getrawtransaction.locktime.toLocaleString()}
										span  or later
										a(href="https://bitcoin.org/en/developer-guide#locktime-and-sequence-number", data-toggle="tooltip", title="More info about locktime", target="_blank")
											i.fas.fa-info-circle
									else
										span Spendable after #{moment.utc(new Date(result.getrawtransaction.locktime * 1000)).format("Y-MM-DD HH:mm:ss")} (utc)
										a(href="https://bitcoin.org/en/developer-guide#locktime-and-sequence-number", data-toggle="tooltip", title="More info about locktime", target="_blank")
											i.fas.fa-info-circle

						if (isTxConfirmed)
							div.row
								div.summary-table-label Confirmations
								div.summary-table-content.text-monospace
									if (result.getrawtransaction.confirmations < 6)
										span.font-weight-bold.text-warning #{result.getrawtransaction.confirmations.toLocaleString()}
											a(data-toggle="tooltip", title="Fewer than 6 confirmations is generally considered 'unsettled' for high-value transactions. The applicability of this guidance may vary.")
												i.fas.fa-unlock-alt
									else
										strong.font-weight-bold.text-success #{result.getrawtransaction.confirmations.toLocaleString()}
											a(data-toggle="tooltip", title="6 confirmations is generally considered 'settled'. High-value transactions may require more; low-value transactions may require less.")
												i.fas.fa-lock

						//only coinbase have 0 inputs
						if (result.getrawtransaction.vin.length == 0)
							div.row
								div.summary-table-label Fees Collected
								div.summary-table-content.text-monospace
									- var currencyValue = new Decimal(totalOutputValue).minus(totalInputValue);
									include includes/value-display.pug

							- var blockRewardMax = coinConfig.blockRewardFunction(result.blockHeader.height, activeBlockchain);
							if (parseFloat(totalOutputValue) < parseFloat(blockRewardMax))
								div.row
									div.summary-table-label
										span.border-dotted(data-toggle="tooltip" title="The miner of this transaction's block failed to collect this value. As a result, it is permanently lost.") Fees Destroyed
									div.summary-table-content.text-monospace.text-danger
										- var currencyValue = new Decimal(blockRewardMax).minus(totalOutputValue);
										include includes/value-display.pug

							- var miner = utils.getMinerFromCoinbaseTx(result.getrawtransaction);
							if (miner)
								div.row
									div.summary-table-label Miner
									div.summary-table-content.text-monospace
										include includes/coinbase-display.pug

						else

							- var feePaid = new Decimal(result.getrawtransaction.fee)

							div.row
								div.summary-table-label Fee Paid
								div.summary-table-content.text-monospace
									- var currencyValue = feePaid;
									include includes/value-display.pug

							if (feePaid > 0)
								div.row
									div.summary-table-label Fee Rate
									div.summary-table-content.text-monospace
										- var currencyValue = new DecimalRounded(result.getrawtransaction.fee).dividedBy(result.getrawtransaction.size);
										- var currencyValueDecimals = 2;
										- currencyFormatTypeOverride = "sat";
										- currencyUnitSuffix = "/B"
										include includes/value-display.pug
										- currencyFormatTypeOverride = null
										- currencyUnitSuffix = null

							- var daysDestroyed = new Decimal(0);
							each xInput, xInputIndex in result.getrawtransaction.vin
								- var vout = null;
								if (result.txInputs && result.txInputs[xInputIndex])
									- var vout = result.txInputs[xInputIndex];

									if (vout.utxoTime)
										- var dt = result.getrawtransaction.time - vout.utxoTime;
										- var dtDays = dt / 60 / 60 / 24;
										- daysDestroyed = daysDestroyed.plus(new Decimal(vout.value).times(dtDays));

							if (parseInt(daysDestroyed) > 0)
								div.row
									div.summary-table-label
										span.border-dotted(title=`The sum of all input values multiplied by the number of days that input's UTXO existed before being spent. Large values can sometimes be interesting, indicating the spending of long-dormant coins. A 1 ${coinConfig.ticker} UTXO spent after 7 days dormant results in 7 days destroyed, as does a 7 ${coinConfig.ticker} UTXO spent after 1 day dormant.`, data-toggle="tooltip") Days Destroyed
									div.summary-table-content.text-monospace
										span #{utils.addThousandsSeparators(daysDestroyed.toDP(daysDestroyed > 1 ? 0 : 1))}
											small.ml-1.border-dotted(title=`${coinConfig.name} Days`, data-toggle="tooltip") #{coinConfig.ticker.toLowerCase().substring(0, 1)}d
							if (result.ballot != null)
								div.summary-table-label Election ballot
								div.summary-table-content.text-monospace
									p This is a vote for #{result.ballot[1]} in election #{result.ballot[0]}.

									p To learn more about on-chain elections see&nbsp;
										a(href=("https://voter.cash")) voter.cash
											i.fas.fa-file-signature

						if (result.isflipstarter)
								p This looks like a Flipstarter transaction&nbsp;
									i.fas.fa-glass-cheers


								p Flipstarter is a DeFi crowdfunding platform for Bitcoin Cash.

								p Check out&nbsp;
										a(href=("https://flipstarters.bitcoincash.network")) active and historical flipstarters.

								p Run&nbsp;
									a(href=("https://flipstarter.cash")) your own flipstarter crowdfunding campaign.
						if (result.inputPayloadContract != null)
							p This looks like an&nbsp;
								a(href=("https://nerdekollektivet.gitlab.io/votepeer-documentation/input-payload-contract/")) Input Payload Contract
								span &nbsp;transaction. Input Payload Contract is used to deliver a chunk of arbitrary data on the blockchain.

							p The embedded data is #{result.inputPayloadContract.length} bytes. This is the embedded data:
								div.highlight
									pre
										code.json.bg-light(data-lang="json") "#{result.inputPayloadContract}"



				if (result.getrawtransaction.vin.length == 0)
					div.card.shadow-sm.mb-3
						div.card-body.px-2.px-md-3
							h2.h6.mb-0 Coinbase
							hr

							h6 Hex
							- var findex = result.getrawtransaction.vout.length -1
							div.bg-light.px-2.py-2.mb-3.border
								span.text-monospace.word-wrap #{result.getrawtransaction.vout[findex].scriptPubKey.hex}

							h6 Decoded
							- var minerCustomData = utils.getMinerCustomData(result.getrawtransaction);
							div.bg-light.px-2.py-2.border
								span.text-monospace.word-wrap #{utils.hex2string(result.getrawtransaction.vout[findex].scriptPubKey.hex)}

				div.card.shadow-sm.mb-3
					div.card-body.px-2.px-md-3
						h2.h6.mb-0
							span #{result.getrawtransaction.vin.length.toLocaleString()} 
							if (result.getrawtransaction.vin.length == 1)
								span Input
							else
								span Inputs

							span.mx-2.text-muted.text-small /

							span #{result.getrawtransaction.vout.length.toLocaleString()} 
							if (result.getrawtransaction.vout.length == 1)
								span Output
							else
								span Outputs

						hr

						- var tx = result.getrawtransaction;
						- var txInputs = result.txInputs;
						- var blockHeight = -1;
						if (result && result.blockHeader)
							- blockHeight = result.blockHeader.height;
						include includes/transaction-io-details.pug

				if (txpoolDetails)
					if (txpoolDetails.ancestors.length > 0)
						div.card.shadow-sm.mb-3
							div.card-body.px-2.px-md-3
								h3.h6.mb-0
									// the below is not trailing spaces, it is actually needed
									span #{txpoolDetails.ancestors.length.toLocaleString()} 

									if (txpoolDetails.ancestors.length == 1)
										span Ancestor
									else
										span Ancestors

									hr

								ol.mb-0
									each ancestorTxid, ancestorIndex in txpoolDetails.ancestors
										li
											a.text-monospace(href=("/tx/" + ancestorTxid)) #{ancestorTxid}

					if (txpoolDetails.descendants.length > 0)
						div.card.shadow-sm.mb-3
							div.card-body.px-2.px-md-3
								h3.h6.mb-0
									// the below is not trailing spaces, it is actually needed
									span #{txpoolDetails.descendants.length.toLocaleString()} 
									if (txpoolDetails.descendants.length == 1)
										span Descendant
									else
										span Descendants


								ol.mb-0
									each descendantTxid, descendantIndex in txpoolDetails.descendants
										li
											a.text-monospace(href=("/tx/" + descendantTxid)) #{descendantTxid}


			div.tab-pane(id="tab-scripts", role="tabpanel")
				div.card.shadow-sm.mb-3
					div.card-body.px-2.px-md-3
						h3.h6.mb-0 Input Scripts
						hr

						table.table.table-striped
							thead
								tr
									th(style="width: 50px;")
									th Script Sig (asm)
							tbody
								each vin, vinIndex in result.getrawtransaction.vin
									tr
										th.text-monospace
											a(data-toggle="tooltip", title=("Input #" + vinIndex), style="white-space: nowrap;")
												span >
												span.font-weight-normal ##{vinIndex.toLocaleString()}

										td.word-wrap.text-break.text-monospace
											if (vin.scriptSig && vin.scriptSig.asm)
												span #{vin.scriptSig.asm}

											else if (vin.coinbase)
												div.text-monospace(style="line-height: 1.75em;")
													small.rounded.bg-primary.text-white.px-2.py-1.mr-2 coinbase
													br
													span #{vin.coinbase}
													br
													span.text-muted (decoded) #{utils.hex2string(vin.coinbase)}

				div.card.shadow-sm.mb-3
					div.card-body.px-2.px-md-3
						h3.h6.mb-0 Output Scripts
						hr

						table.table.table-striped
							thead
								tr
									th(style="width: 50px;")
									th Script Pub Key (asm)
							tbody
								each vout, voutIndex in result.getrawtransaction.vout
									tr
										th.text-monospace
											a(data-toggle="tooltip", title=("Output #" + voutIndex), style="white-space: nowrap;")
												span ,
												span.font-weight-normal  ##{voutIndex.toLocaleString()}

										td.word-wrapx.text-monospace
											if (vout.scriptPubKey && vout.scriptPubKey.asm)
												span #{vout.scriptPubKey.asm}
												if (vout.scriptPubKey.asm.startsWith("OP_RETURN"))
													br
													span.text-muted (decoded) #{utils.hex2string(vout.scriptPubKey.hex)}

			div.tab-pane(id="tab-json", role="tabpanel")
				div.card.shadow-sm.mb-3
					div.card-body
						h3.h6.mb-0 Transaction
						hr

						div.highlight
							pre
								code.json.bg-light(data-lang="json") #{result.rawtransaction_parsed}

				if (utxos)
					div.card.shadow-sm.mb-3
						div.card-body
							h3.h6.mb-0 UTXOs
							hr

							div.highlight
								pre
									code.json.bg-light(data-lang="json") #{utxos_parsed}

					if (txpoolDetails)
						h3.h5 Txpool Details
						div.highlight
							pre
								code.json.bg-light(data-lang="json") #{JSON.stringify(txpoolDetails, null, 4)}

				//pre #{JSON.stringify(result.txInputs, null, 4)}
